Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp	(revision 53)
@@ -0,0 +1,149 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  void RegisterFile::allocation (void)
+  {
+    string rename;
+
+    log_printf(FUNC,RegisterFile,"allocation","Begin");
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      in_CLOCK              = new SC_CLOCK           ("in_CLOCK" );
+      in_NRESET             = new SC_IN (Tcontrol_t) ("in_NRESET");
+    }
+    // ~~~~~[ Interface : "read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+     in_READ_VAL         = new SC_IN (Tcontrol_t) * [_param._nb_port_read];
+    out_READ_ACK         = new SC_OUT(Tcontrol_t) * [_param._nb_port_read];
+     in_READ_ADDRESS     = new SC_IN (Taddress_t) * [_param._nb_port_read];
+    out_READ_DATA        = new SC_OUT(Tdata_t   ) * [_param._nb_port_read];
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      { 
+	rename =  "in_READ_"+toString(i)+"_VAL"    ;
+	 in_READ_VAL     [i]  = new SC_IN (Tcontrol_t) (rename.c_str());   
+	rename = "out_READ_"+toString(i)+"_ACK"    ;
+	out_READ_ACK     [i]  = new SC_OUT(Tcontrol_t) (rename.c_str());
+	rename =  "in_READ_"+toString(i)+"_ADDRESS";
+	 in_READ_ADDRESS [i]  = new SC_IN (Taddress_t) (rename.c_str());
+	rename = "out_READ_"+toString(i)+"_DATA"   ;
+	out_READ_DATA    [i]  = new SC_OUT(Tdata_t   ) (rename.c_str());
+      }
+
+    // ~~~~~[ Interface : "write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+     in_WRITE_VAL        = new SC_IN (Tcontrol_t) * [_param._nb_port_write];
+    out_WRITE_ACK        = new SC_OUT(Tcontrol_t) * [_param._nb_port_write];
+     in_WRITE_ADDRESS    = new SC_IN (Taddress_t) * [_param._nb_port_write];
+     in_WRITE_DATA       = new SC_IN (Tdata_t   ) * [_param._nb_port_write];
+    
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	rename =  "in_WRITE_"+toString(i)+"_VAL"    ;
+	 in_WRITE_VAL     [i]  = new SC_IN (Tcontrol_t) (rename.c_str());
+	rename = "out_WRITE_"+toString(i)+"_ACK"    ;
+	out_WRITE_ACK     [i]  = new SC_OUT(Tcontrol_t) (rename.c_str());
+	rename =  "in_WRITE_"+toString(i)+"_ADDRESS";
+	 in_WRITE_ADDRESS [i]  = new SC_IN (Taddress_t) (rename.c_str());
+	rename =  "in_WRITE_"+toString(i)+"_DATA"   ;
+	 in_WRITE_DATA    [i]  = new SC_IN (Tdata_t   ) (rename.c_str());
+      }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                                                
+    if (_param._instance == instance_RegisterFile_Monolithic)
+    // =====[ component_RegisterFile_Monolithic ]=========================
+      {
+	component_RegisterFile_Monolithic  = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   (_name.c_str()
+#ifdef STATISTICS
+																					       ,_param_statistics
+#endif
+																					       ,*(_param._param_registerfile_monolithic)
+																					       );
+	
+      }
+    else
+    // =====[ component_RegisterFile_Multi_Banked ]=======================
+      {
+	component_RegisterFile_Multi_Banked = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked (_name.c_str()
+#ifdef STATISTICS
+																						,_param_statistics
+#endif
+																						,*(_param._param_registerfile_multi_banked)
+																						);
+	
+      }
+    // ~~~~~[ Component - Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    if (_param._instance == instance_RegisterFile_Monolithic)
+    // =====[ Component_RegisterFile_Monolithic - Instanciation ]=========
+      {
+	(*(component_RegisterFile_Monolithic  ->in_CLOCK )) (*(in_CLOCK ));
+	(*(component_RegisterFile_Monolithic  ->in_NRESET)) (*(in_NRESET));
+	
+	for (uint32_t i=0; i<_param._nb_port_read; i++)
+	  { 
+	    (*(component_RegisterFile_Monolithic  -> in_READ_VAL     [i])) (*( in_READ_VAL     [i]));   
+	    (*(component_RegisterFile_Monolithic  ->out_READ_ACK     [i])) (*(out_READ_ACK     [i]));
+	    (*(component_RegisterFile_Monolithic  -> in_READ_ADDRESS [i])) (*( in_READ_ADDRESS [i]));
+	    (*(component_RegisterFile_Monolithic  ->out_READ_DATA    [i])) (*(out_READ_DATA    [i]));
+	  }
+	
+	for (uint32_t i=0; i<_param._nb_port_write; i++)
+	  {
+	    (*(component_RegisterFile_Monolithic  -> in_WRITE_VAL     [i])) (*( in_WRITE_VAL     [i]));
+	    (*(component_RegisterFile_Monolithic  ->out_WRITE_ACK     [i])) (*(out_WRITE_ACK     [i]));
+	    (*(component_RegisterFile_Monolithic  -> in_WRITE_ADDRESS [i])) (*( in_WRITE_ADDRESS [i]));
+	    (*(component_RegisterFile_Monolithic  -> in_WRITE_DATA    [i])) (*( in_WRITE_DATA    [i]));
+	  }
+      }
+    else
+    // =====[ Component_RegisterFile_Multi_Banked - Instanciation ]=======
+      {
+	(*(component_RegisterFile_Multi_Banked->in_CLOCK )) (*(in_CLOCK ));
+	(*(component_RegisterFile_Multi_Banked->in_NRESET)) (*(in_NRESET));
+	
+	for (uint32_t i=0; i<_param._nb_port_read; i++)
+	  { 
+	    (*(component_RegisterFile_Multi_Banked-> in_READ_VAL     [i])) (*( in_READ_VAL     [i]));   
+	    (*(component_RegisterFile_Multi_Banked->out_READ_ACK     [i])) (*(out_READ_ACK     [i]));
+	    (*(component_RegisterFile_Multi_Banked-> in_READ_ADDRESS [i])) (*( in_READ_ADDRESS [i]));
+	    (*(component_RegisterFile_Multi_Banked->out_READ_DATA    [i])) (*(out_READ_DATA    [i]));
+	  }
+	
+	for (uint32_t i=0; i<_param._nb_port_write; i++)
+	  {
+	    (*(component_RegisterFile_Multi_Banked-> in_WRITE_VAL     [i])) (*( in_WRITE_VAL     [i]));
+	    (*(component_RegisterFile_Multi_Banked->out_WRITE_ACK     [i])) (*(out_WRITE_ACK     [i]));
+	    (*(component_RegisterFile_Multi_Banked-> in_WRITE_ADDRESS [i])) (*( in_WRITE_ADDRESS [i]));
+	    (*(component_RegisterFile_Multi_Banked-> in_WRITE_DATA    [i])) (*( in_WRITE_DATA    [i]));
+	  }
+      }
+
+    if (_param._instance == instance_RegisterFile_Monolithic)
+      _component = component_RegisterFile_Monolithic  ->_component;
+    else
+      _component = component_RegisterFile_Multi_Banked->_component;
+
+    log_printf(FUNC,RegisterFile,"allocation","End");
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_deallocation.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_deallocation.cpp	(revision 53)
@@ -0,0 +1,52 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  void RegisterFile::deallocation (void)
+  {
+    log_printf(FUNC,RegisterFile,"deallocation","Begin");
+
+    delete in_CLOCK;
+    delete in_NRESET;
+    // ----- Interface Read
+    delete []  in_READ_VAL    ;
+    delete [] out_READ_ACK    ;
+    delete []  in_READ_ADDRESS;
+    delete [] out_READ_DATA   ;
+
+    // ----- Interface Write
+    delete []  in_WRITE_VAL    ;
+    delete [] out_WRITE_ACK    ;
+    delete []  in_WRITE_ADDRESS;
+    delete []  in_WRITE_DATA   ;
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+//   delete _component;
+
+    if (_param._instance == instance_RegisterFile_Monolithic)
+      delete component_RegisterFile_Monolithic  ;
+    else
+      delete component_RegisterFile_Multi_Banked;
+
+    log_printf(FUNC,RegisterFile,"deallocation","End");
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_statistics.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_statistics.cpp	(revision 53)
@@ -0,0 +1,38 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+
+
+  string RegisterFile::statistics (uint32_t depth)
+  {
+    log_printf(FUNC,RegisterFile,"statistics","Begin");
+    
+    if (_param->_instance == instance_RegisterFile_Monilithic)
+      component_RegisterFile_Monolithic  ->statistics(depth);
+    else
+      component_RegisterFile_Multi_Banked->statistics(depth);
+
+    string txt = _stat->print(depth);
+    
+    log_printf(FUNC,RegisterFile,"statistics","End");
+
+    return txt;
+  };
+
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest	(revision 53)
@@ -2,5 +2,5 @@
 # $Id$
 # 
-# [ Description ]
+# [ Description ]
 # 
 # Makefile
@@ -14,5 +14,5 @@
 DIR_LOG				= log
 
-#-----[ Variables ]----------------------------------------
+#-----[ Variables ]----------------------------------------
 CFG_FILE_EXTENSION		= cfg
 CFG_FILE_DEBUG       		= debug.$(CFG_FILE_EXTENSION)
@@ -25,5 +25,5 @@
 EXEC				= soft
 
-#-----[ Rules ]--------------------------------------------
+#-----[ Rules ]--------------------------------------------
 .PRECIOUS			: $(DIR_BIN)/%.x $(DIR_LOG)/%.exec.log
 .NOPARALLEL			: clean clean_all help
@@ -112,5 +112,15 @@
 				done;
 
-$(DIR_LOG)/%.exec.log		: $(DIR_CFG_GEN)/%.cfg $(DIR_BIN)/$(EXEC).x
+$(DIR_LOG)/%.exec.log		: $(DIR_CFG_GEN)/%.cfg  $(DIR_BIN)/$(EXEC).x
+				@\
+				$(ECHO) "Execute            : $*";\
+				$(EXPORT) SYSTEMC=$(SYSTEMC_$(SIMULATOR)) ; ./$(DIR_BIN)/$(EXEC).x $(EXEC_PARAMS) $* `$(CAT) $<` &> $@
+				declare -i count=`$(GREP) -ch "Test OK" $@`;		\
+				if $(TEST) $$count -ne 0;       			\
+				then echo "                     $* ... OK";           	\
+				else echo "                     $* ... KO"; exit 1;     \
+				fi;
+
+$(DIR_LOG)/%.exec.log		: $(DIR_CFG_USER)/%.cfg $(DIR_BIN)/$(EXEC).x
 				@\
 				$(ECHO) "Execute            : $*";\
@@ -155,5 +165,5 @@
 selftest_help			:
 				@\
-				$(ECHO) " -----[ Selftest ]-----------------------------------";\
+				$(ECHO) " -----[ Selftest ]-----------------------------------";\
 				$(ECHO) "";\
 				$(ECHO) " * all_selftest         : compile all c++ file and execute";\
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.deps	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.deps	(revision 53)
@@ -8,9 +8,9 @@
 # DIR_MORPHEO must be defined
 
+Behavioural			= yes
+
 #ifndef Behavioural
 #include $(DIR_MORPHEO)/Behavioural/Makefile.deps
 #endif
-#
-Behavioural			= yes
 
 #-----[ Library ]------------------------------------------
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags	(revision 53)
@@ -11,14 +11,13 @@
 # systemc			- SystemC    
 # systemcass 			- SystemCASS
-# systemcass_deps		- SystemCASS, and use port dependency information instead of sensitivity list
+# systemcass_deps		- Systemcass, and use port dependency information instead of sensitivity list
 
 #-----[ Flags ]--------------------------------------------
 FLAGS				=	-DSYSTEMC		\
-					-DVHDL			\
-					-DDEBUG=DEBUG_NONE
-
+					-DDEBUG=DEBUG_TRACE
+#					-DVHDL			\
 #  					-DVHDL_TESTBENCH	\
+#					-DVHDL_TESTBENCH_ASSERT	\
 #					-DSTATISTICS 		\
-#					-DVHDL_TESTBENCH_ASSERT	\
 #					-DCONFIGURATION  	\
 #					-DPOSITION       	\
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/SelfTest/src/test.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/SelfTest/src/test.cpp	(revision 53)
@@ -33,9 +33,13 @@
   cout << "<" << name << "> : Simulation SystemC" << endl;
 
+#ifdef STATISTICS
+  morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,50);
+#endif
+
   @COMPONENT * _@COMPONENT = new @COMPONENT (name.c_str(),
 #ifdef STATISTICS
-					     morpheo::behavioural::Parameters_Statistics(5,50),
+					     _parameters_statistics,
 #endif
-					     *_param);
+					     _param);
   
 #ifdef SYSTEMC
@@ -43,11 +47,11 @@
    * Déclarations des signaux
    *********************************************************************/
-  sc_clock                               * CLOCK;
-  sc_signal<Tcontrol_t>                  * NRESET;
+  sc_clock                               * in_CLOCK;
+  sc_signal<Tcontrol_t>                  * in_NRESET;
 
   string rename;
 
-  CLOCK                                  = new sc_clock ("clock", 1.0, 0.5);
-  NRESET                                 = new sc_signal<Tcontrol_t> ("NRESET");
+  in_CLOCK                                = new sc_clock ("clock", 1.0, 0.5);
+  in_NRESET                               = new sc_signal<Tcontrol_t> ("NRESET");
   
   /********************************************************
@@ -57,6 +61,6 @@
   cout << "<" << name << "> Instanciation of _@COMPONENT" << endl;
   
-  (*(_@COMPONENT->in_CLOCK))        (*(CLOCK));
-  (*(_@COMPONENT->in_NRESET))       (*(NRESET));
+  (*(_@COMPONENT->in_CLOCK))        (*(in_CLOCK));
+  (*(_@COMPONENT->in_NRESET))       (*(in_NRESET));
 
 
@@ -100,3 +104,6 @@
 
   delete _@COMPONENT;
+#ifdef SYSTEMC
+  delete _parameters_statistics;
+#endif
 }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/New_Component.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/New_Component.h	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/New_Component.h	(revision 53)
@@ -40,9 +40,9 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string     _name;
+  protected : const string       _name;
 
-  protected : const Parameters _param;
+  protected : const Parameters * _param;
 //#ifdef STATISTICS
-//  protected : const morpheo::behavioural::Parameters_Statistics _param_statistics;
+//  protected : const morpheo::behavioural::Parameters_Statistics * _param_statistics;
 //#endif
 
@@ -74,14 +74,12 @@
   public  :          @COMPONENT              (
 #ifdef SYSTEMC
-					      sc_module_name                              name,
+					      sc_module_name                                name,
 #else					       
-					      string                                      name,
+					      string                                        name,
 #endif					       
 #ifdef STATISTICS
-					      morpheo::behavioural::Parameters_Statistics param_statistics,
+					      morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-					      Parameters                                  param );
-					       
-  public  :          @COMPONENT              (Parameters param );
+					      Parameters                                  * param );
   public  :          ~@COMPONENT             (void);
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/Statistics.h	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/include/Statistics.h	(revision 53)
@@ -25,10 +25,10 @@
   {
     // -----[ fields ]----------------------------------------------------
-  private  : const Parameters                                   _parameters;
+  private  : const Parameters                                 * _parameters;
 
     // -----[ methods ]---------------------------------------------------
-  public   : Statistics  (string                                      name                       ,
-			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
-			  Parameters                                  parameters
+  public   : Statistics  (string                                        name                       ,
+			  morpheo::behavioural::Parameters_Statistics * parameters_statistics      ,
+			  Parameters                                  * parameters
 			  );
 //public   : Statistics  (Statistics & stat);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp	(revision 53)
@@ -12,4 +12,6 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::@COMPONENT"
 #ifdef SYSTEMC
   @COMPONENT::@COMPONENT (sc_module_name name,
@@ -18,7 +20,7 @@
 #endif
 #ifdef STATISTICS
-			      morpheo::behavioural::Parameters_Statistics             param_statistics,
+			  morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-			      morpheo::behavioural::@NAMESPACE_USE::Parameters param ):
+			  morpheo::behavioural::@NAMESPACE_USE::Parameters * param ):
 			      _name              (name)
 			      ,_param            (param)
@@ -27,8 +29,8 @@
 // #endif
   {
-    log_printf(FUNC,@COMPONENT,"@COMPONENT","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef SYSTEMC
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Allocation");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Allocation");
 
     allocation ();
@@ -36,5 +38,5 @@
 
 #ifdef STATISTICS
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Allocation of statistics");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Allocation of statistics");
 
     // Allocation of statistics
@@ -46,5 +48,5 @@
 #ifdef VHDL
     // generate the vhdl
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Generate the vhdl");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Generate the vhdl");
 
     vhdl();
@@ -53,5 +55,5 @@
 #ifdef SYSTEMC
 //#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Method - transition");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Method - transition");
 
     SC_METHOD (transition);
@@ -65,13 +67,15 @@
 
 #endif
-    log_printf(FUNC,@COMPONENT,"@COMPONENT","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
   
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::~@COMPONENT"
   @COMPONENT::~@COMPONENT (void)
   {
-    log_printf(FUNC,@COMPONENT,"~@COMPONENT","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef STATISTICS
-    log_printf(INFO,@COMPONENT,"~@COMPONENT","Generate Statistics file");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Generate Statistics file");
 
     _stat->generate_file(statistics(0));
@@ -81,10 +85,10 @@
 
 #ifdef SYSTEMC
-    log_printf(INFO,@COMPONENT,"~@COMPONENT","Deallocation");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Deallocation");
 
     deallocation ();
 #endif
 
-    log_printf(FUNC,@COMPONENT,"~@COMPONENT","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp	(revision 53)
@@ -13,9 +13,12 @@
 @NAMESPACE_BEGIN
 
+
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::allocation"
   void @COMPONENT::allocation (void)
   {
     string rename;
 
-    log_printf(FUNC,@COMPONENT,"allocation","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     _component   = new Component ();
@@ -49,5 +52,5 @@
 #endif
 
-    log_printf(FUNC,@COMPONENT,"allocation","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp	(revision 53)
@@ -1,2 +1,5 @@
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::"
+
 #ifdef SYSTEMC
 /*
@@ -13,12 +16,14 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::deallocation"
   void @COMPONENT::deallocation (void)
   {
-    log_printf(FUNC,@COMPONENT,"deallocation","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 //#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    delete in_CLOCK;
+    delete    in_CLOCK ;
 //#endif
-    delete in_NRESET;
+    delete    in_NRESET;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
@@ -26,5 +31,5 @@
     delete _component;
 
-    log_printf(FUNC,@COMPONENT,"deallocation","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp	(revision 53)
@@ -13,11 +13,13 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::statistics"
   string @COMPONENT::statistics (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"statistics","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string txt = _stat->print(depth);
     
-    log_printf(FUNC,@COMPONENT,"statistics","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
 
     return txt;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp	(revision 53)
@@ -14,7 +14,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::transition"
   void @COMPONENT::transition (void)
   {
-    log_printf(FUNC,@COMPONENT,"transition","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef STATISTICS
@@ -26,5 +28,5 @@
 #endif
 
-    log_printf(FUNC,@COMPONENT,"transition","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp	(revision 53)
@@ -14,7 +14,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl"
   void @COMPONENT::vhdl (void)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     Vhdl * vhdl = new Vhdl (_name);
@@ -30,5 +32,5 @@
     delete vhdl;
 
-    log_printf(FUNC,@COMPONENT,"vhdl","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp	(revision 53)
@@ -13,9 +13,11 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_body"
   void @COMPONENT::vhdl_body (Vhdl * & vhdl)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_body","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     vhdl->set_body ("");
-    log_printf(FUNC,@COMPONENT,"vhdl_body","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp	(revision 53)
@@ -13,8 +13,10 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_declaration"
   void @COMPONENT::vhdl_declaration (Vhdl * & vhdl)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_declaration","Begin");
-    log_printf(FUNC,@COMPONENT,"vhdl_declaration","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp	(revision 53)
@@ -13,7 +13,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_testbench_transition"
   void @COMPONENT::vhdl_testbench_transition ()
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_testbench_transition","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     // Evaluation before read the ouput signal
@@ -22,5 +24,5 @@
     _interfaces->testbench();
 
-    log_printf(FUNC,@COMPONENT,"vhdl_testbench_transition","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp	(revision 53)
@@ -12,22 +12,28 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::Parameters"
   Parameters::Parameters ()
   {
-    log_printf(FUNC,@COMPONENT,"Parameters","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     test();
-    log_printf(FUNC,@COMPONENT,"Parameters","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
   
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::Parameters (copy)"
   Parameters::Parameters (Parameters & param)
   {
-    log_printf(FUNC,@COMPONENT,"Parameters (copy)","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     test();
-    log_printf(FUNC,@COMPONENT,"Parameters (copy)","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::~Parameters"
   Parameters::~Parameters () 
   {
-    log_printf(FUNC,@COMPONENT,"~Parameters","Begin");
-    log_printf(FUNC,@COMPONENT,"~Parameters","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp	(revision 53)
@@ -15,7 +15,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::msg_error"
   string Parameters::msg_error(void)
   {
-    log_printf(FUNC,@COMPONENT,"msg_error","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string msg = "";
@@ -23,5 +25,5 @@
     return msg;
 
-    log_printf(FUNC,@COMPONENT,"msg_error","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp	(revision 53)
@@ -14,25 +14,32 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::print"
   string Parameters::print (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"print","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     XML xml ("@COMPONENT_LOWER");
 
     xml.balise_open("@COMPONENT_LOWER");
-//  xml.singleton_begin("size_data"); xml.attribut("value",toString(_size_data)); xml.singleton_end();
-//  xml.singleton_begin("nb_port  "); xml.attribut("value",toString(_nb_port  )); xml.singleton_end();
+//  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
     xml.balise_close();
 
-    log_printf(FUNC,@COMPONENT,"print","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
     
     return xml.get_body(depth);
   };
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::operator<<"
   ostream& operator<< (ostream& output_stream ,
 		       morpheo::behavioural::@NAMESPACE_USE::Parameters & x)
   {
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+
     output_stream << x.print(0);
     
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
+
     return output_stream;
   };
